' ************************************
' *      5x8Matrix-6 Clock Demo      *
' *   LED-Basic >= 15.2.7 required   *
' *  modyfied by Hurrug   Ver, 1.02  *
' ************************************
'
' Bedienungsanleitung:
'
' Encoder,
' Bei Neustart und gleichzeitig gedrckter Taste whrend der Versionsanzeige (halten bis
' Beep hrbar), erfolgt eine Zurcksetzung auf (Standard) Werte. (Bitte ausfhren falls
' Funktionen nicht funktionieren).
'
'
' Kurzer Druck auf Taste zeigt das Datum / Temperatur.
' Langer Druck auf Taste wechselt den MODUS (Uhr --> Stoppuhr --> Timer --> Uhr).
'    Die Auswahl erfolgt durch kurzen Druck.
'
' Stoppuhr: (max 23:59:59) (blau)
'    kurzer Druck = start/stopp/weiter.
'    langer Druck whrend des Zhlens = zurck zur Uhr.
'    langer Druck bei Stopp = zurck zum Modus Auswahl (Reset).
'    (Bei Maximum automatisch mit Sound zurck auf Uhr).
'
'
' Timer: (max 23:59:59) (grn)
'    Timer set:
'        kurzer Druck = Auswahl Stunde, Minute, Sekunde (Punkte blinken).
'        Encoder (Drehrad) = Wert.
'        langer Druck = Timer start.
'    Timer start:
'        kurzer Druck = stopp/weiter.
'        langer Druck whrend des Zhlens = zurck zur Uhr.
'        langer Druck bei Stopp = zurck zum Modus Auswahl (Reset).
'    (Timer null = automatisch mit Sound zurck auf Uhr).
'
'
' Encoder (Drehrad):
' Drehsequenz (Auswahl durch kurzen Druck) :
' -> Alarm (An/Aus), An = Punkt bei Sek. plus zyklische Alarm Anzeige.
'     Alarmdauer = 1 Minute, durch Taste unterbrechbar.
' -> Auto Datum / Temp (An/Aus), An = zyklische Datum / Temp Anzeige.
' -> Tasten Beep (An/Aus).
' -> Random (Spielautomat) (An/Aus), An = Zyklische Spielautomat Anzeige.
' -> Helligkeit, 0-15 (0 = Auto Sensor) (8)
' -> Alarm Zeit: (Drehrad = Wert) (12:00)
'     Langer Druck speichert die Einstellung.
'     Kurzer Druck wechselt zwischen Minuten, Stunden (Auswahl angezeigt durch Punkte).
' -> Zeit: (Drehrad = Wert)
'     Langer Druck speichert die Einstellung.
'     Kurzer Druck wechselt zwischen Stunden, Minuten, Sekunden (Auswahl angezeigt durch Punkte).
' -> Datum: (Drehrad = Wert)
'     Langer Druck speichert die Einstellung.
'     Kurzer Druck wechselt zwischen Monat, Tag, Jahr (Auswahl angezeigt durch Punkte).
' -> Farbe: 0-12 (12)
'     rot, orange, gelb, grn, blau, magenta,
'     RGB all, Farbfade, weiss, RGB fade 1, RGB fade 2, RGB fade 3, incandecent
' -> Uhr Animation: 0-2 (0)
'     0 = keine Animation, 1 = Ziffern Wechsel, 2 = Ziffern und bergnge plus Wochentag.
'
' Bei Nichtbettigung abbruch nach ca. 8 Sekungen oder durch langen Tastendruck.
'
'
' Alle Einstellungen bleiben bei Stromausfall erhalten (EEPROM).
' Bei angeschlossenem Terminal (PC) weitere Ausgabe von Werten.
' Alarm ist priorisiert bei Timer / Stoppuhr.
' Versionsanzeige bei Uhrenstart.
' Softwarecheck bei Systemstart.
' Random (Spielautomat) Anzeige (an / abschaltbar).
' Datum / Temp auto Anzeige (an / abschaltbar).
' Tasten-Beep (an / abschaltbar).
'
'
' BITTE BEACHTEN !!
' Index bis 64 mglich --> LED.ihsv(Index, h, s, v)
' Die Chip Temperatur wird nur alle 64 Sekunden intern aktualisiert !
'===========================================================
### L240 P1 S3 CGRB M60 F30
' Set initial EEPROM state (for testing, uncomment to set on run)
'    IO.eewrite(0, 102)    ' 0 = Version (102)
'    IO.eewrite(1, 8)      ' 1 = Helligkeit (8)
'    IO.eewrite(2, 0)      ' 2 = Alarm  (0)
'    IO.eewrite(3, 12)     ' 3 = Alarm Zeit Stunde (12)
'    IO.eewrite(4, 0)      ' 4 = Alarm Zeit Minute (0)
'    IO.eewrite(5, 0)      ' 5 = Datum / Temp auto Anzeige (0)
'    IO.eewrite(6, 0)      ' 6 = Mode  (0)
'    IO.eewrite(7, 1)      ' 7 = Tasten-Beep  (1)
'    IO.eewrite(8, 0)      ' 8 = Random Modus (Spielautomat) (0)
'    IO.eewrite(9, 12)     ' 9 = Farbe  (12 incandecent)
'    IO.eewrite(10, 0)     ' 10 = Uhr Animation (0)
'
' MONTAG
1:  data 13,32,32,32,32,32,32,77,79,78,84,65,71,32,32,32,32,32,32
' DIENSTAG
2:  data 15,32,32,32,32,32,32,68,73,69,78,83,84,65,71,32,32,32,32,32,32
' MITTWOCH
3:  data 15,32,32,32,32,32,32,77,73,84,84,87,79,67,72,32,32,32,32,32,32
' DONNERSTAG
4:  data 17,32,32,32,32,32,32,68,79,78,78,69,82,83,84,65,71,32,32,32,32,32,32
' FREITAG
5:  data 14,32,32,32,32,32,32,70,82,69,73,84,65,71,32,32,32,32,32,32
' SAMSTAG
6:  data 14,32,32,32,32,32,32,83,65,77,83,84,65,71,32,32,32,32,32,32
' SONNTAG
7:  data 14,32,32,32,32,32,32,83,79,78,78,84,65,71,32,32,32,32,32,32
' *Olaf*
18: data 42,79,108,97,102,42
' 0815OK
19: data 0,8,1,5,79,75
' Hurrug
20: data 72,117,114,114,117,103
' AutoDa
21: data 65,117,116,111,68,97
' Alarm
22: data 65,108,97,114,109,32
' An
23: data 32,65,110,32,32,32
' Aus
24: data 32,65,117,115,32,32
' TaBeep
25: data 84,97,66,101,101,112
' Random
26: data 82,97,110,100,111,109
' Hell
27: data 72,101,108,108,32,32
' AlZeit
28: data 65,108,90,101,105,116
' Zeit
29: data 90,101,105,116,32,32
' Datum
30: data 68,97,116,117,109,32
' Stoppuhr
31: data 32,32,32,32,32,32,83,116,111,112,112,117,104,114,32,32,32,32,32,32
' Timer
32: data 32,32,32,32,32,32,84,105,109,101,114,32,32,32,32,32,32
' Farbe
33: data 70,97,114,98,101,32
' UhrAni
34: data 85,104,114,65,110,105
' Alarm!
35: data 65,108,97,114,109,33
' Music Timer / Stoppuhr max :-)
39:
data 8, 200, 8, 200, 8, 200, 4, 100, 11, 50, 8, 200, 4, 100, 11, 50, 8, 400,
data 15, 200, 15, 200, 15, 200, 16, 100, 11, 50, 7, 200 ,4, 100, 11, 50, 8, 400,
data 20, 200, 8, 100, 8, 50, 20, 200, 19, 100, 18, 50 , 17, 50, 16 ,50 , 17, 100, 0, 1,
data 9, 100, 14, 200, 13, 100, 12, 50, 11, 50, 10, 50, 11, 100, 0, 1, 255
40:
data 4, 100, 7, 200, 4, 100, 7, 50, 11, 200, 8, 100, 11, 50, 15, 400,
data 20, 200, 8, 100, 8, 50, 20, 200, 19, 100, 18, 50, 17, 50, 16, 50, 17, 100, 0, 1,
data 9, 100, 14, 200, 13, 100, 12, 50, 11, 50, 10, 50, 11, 100, 0, 1,
data 4, 100, 7, 200, 4, 100, 11, 50, 8, 200, 4, 100, 11, 50, 8, 400, 255
' Helligkeit (0...15)
41: data 0, 14, 20, 25, 31, 40, 51, 61, 77, 90, 110, 133, 160, 189, 221, 255
' Farben (rot, orange, gelb, grn, blau, magenta)
42: data 0, 20, 50, 120, 240, 340
'===========================================================
' GLOBAL VARS
' t = temp, i = loop, rs = sekunde, lm = minute, on = stunde
' c = Farbe, d = digit, v = helligkeit, k = taster,
' x = sek-zhler, e = encoder, a = alarm flag, z = zhler
'===========================================================
    LED.blackout()
    v = 128 ' init helligkeit
    LED.irgb(0, 0, 0, 0) ' aus
    LED.ihsv(2, 0, 0, v) ' weiss
    MATRIX.setfont(2)
' Logo
    gosub 2000
' Version
    for i = 7 downto 0
     for d = 0 to 5
      MATRIX.select(d)
      LED.ihsv(1, read 42, d, 255, v)
      MATRIX.char(0, i, read 19, d, 1) ' Version
     next d
     LED.show()
     delay 100
    next i
    delay 1000
    if (IO.eeread(10)) > 1 gosub 1000 ' Digit Play ausblendend
'===========================================================
' EEPROM INIT
    if (IO.getkey()) = 1 gosub 8000 ' Softwareversion check or reset
    print "5x8Matrix-6 Clock Demo"
    print "     by Vanessa"
    for i = 0 to 10  ' EEPROM data output
     t = IO.eeread(i)
     print "EEP[";i;"] = ";t
    next i
99:
    LED.iall(0)
    a = 1 ' alarm flag
    c = IO.eeread(9) ' Farbe
    gosub 110 ' helligkeit
    e = 0 ' Encoder
    z = 0 ' zhler
    IO.setenc(e, 1, 0)
    if (IO.eeread(6)) = 1 goto 5000 ' MODE Stoppuhr
    if (IO.eeread(6)) = 2 goto 6000 ' MODE Timer
'===========================================================
' loop
100:
    if e <> (IO.getenc()) goto 500 ' Encoderauwertung
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 and a = 1 then a = 0 ' alarm flag
    if k = 1 goto 108    ' Datum / Temp
    if k = 11 goto 5000  ' MODE Stoppuhr
    s = IO.getrtc(0) ' SEKUNDEN
    if x = s goto 102
    if (IO.eeread(10)) > 0 then w = 7 else w = 0' shift
    x = s
    if s = 0 then a = 1 ' alarm flag
    m = IO.getrtc(1) ' MINUTEN
    n = IO.getrtc(2) ' STUNDEN
    if s > 0 and a = 1 and (IO.eeread(2)) = 1 and (IO.eeread(3)) = n and (IO.eeread(4)) = m goto 410 '9205 ' alarm
    if s % 5 = 0 gosub 110 ' helligkeit
    if m % 2 = 1 and s = 10 and (IO.eeread(2)) = 1 goto 300 ' show alarm
    if m % 2 = 0 and s = 5 and (IO.eeread(8)) = 1 goto 103 ' show random
101:
    if s = 45 and (IO.eeread(5)) = 1 goto 108 ' Auto Datum / Temp anzeigen
102:
    gosub 104 ' show time
    LED.show()
    goto 100
' loop end

103:    'Random
    if m % 10 = 0 goto 400 ' show random
    if m % 10 = 2 goto 3000 ' show pixel
    if m % 10 = 4 goto 3100 ' show lines h
    if m % 10 = 6 goto 3200 ' show lines v
    i = random % 2
    if m % 10 = 8 and i = 1 gosub 2000 else goto 3300 ' show logo
    goto 100
'===========================================================
' SHOW TIME
104:
    MATRIX.setfont(2)
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     if d = 0 and w = 0 then MATRIX.char(0, 0, n / 10, 1)
     if d = 1 and w = 0 then MATRIX.char(0, 0, n % 10, 1)
     if d = 2 and w = 0 then MATRIX.char(0, 0, m / 10, 1)
     if d = 3 and w = 0 then MATRIX.char(0, 0, m % 10, 1)
     if d = 4 and w = 0 then MATRIX.char(0, 0, s / 10, 1)
     if d = 5 and w = 0 then MATRIX.char(0, 0, s % 10, 1)
    next d
    if w > 0 gosub 106 ' shift
    return
106:
    MATRIX.select(5)
    MATRIX.char(0, -w, s % 10, 1)
    if r <> s / 10 then MATRIX.select(4)
    if r <> s / 10 then MATRIX.char(0, -w, s / 10, 1)
    if l % 10 <> m % 10 then MATRIX.select(3)
    if l % 10 <> m % 10 then MATRIX.char(0, w, m % 10, 1)
    if l / 10 <> m / 10 then MATRIX.select(2)
    if l / 10 <> m / 10 then MATRIX.char(0, w, m / 10, 1)
    if o % 10 <> n % 10 then MATRIX.select(1)
    if o % 10 <> n % 10 then MATRIX.char(0, -w, n % 10, 1)
    if o / 10 <> n / 10 then MATRIX.select(0)
    if o / 10 <> n / 10 then MATRIX.char(0, -w, n / 10, 1)
    w = w - 1 ' shift
    if w = 0 then r = s / 10
    if w = 0 then l = m
    if w = 0 then o = n
    delay 50
    return
'===========================================================
' SHOW Date
108:
    if (IO.eeread(10)) > 1 gosub 1000 ' Digit Play ausblendend
    if (IO.eeread(10)) < 2 goto 109 ' DOW nur bei max Animation
    d = IO.getrtc(6) ' DOW
    if d = 1 then t = read 1, 0
    if d = 2 then t = read 2, 0
    if d = 3 then t = read 3, 0
    if d = 4 then t = read 4, 0
    if d = 5 then t = read 5, 0
    if d = 6 then t = read 6, 0
    if d = 7 then t = read 7, 0
    for i = 1 to t ' Wortlnge
     for w = 0 to 5
      if d = 1 then p = read 1, i + w
      if d = 2 then p = read 2, i + w
      if d = 3 then p = read 3, i + w
      if d = 4 then p = read 4, i + w
      if d = 5 then p = read 5, i + w
      if d = 6 then p = read 6, i + w
      if d = 7 then p = read 7, i + w
      gosub 200 ' Farbe
      MATRIX.select(w)
      MATRIX.char(0, 0, p, 1)
     next w
     LED.show()
     delay 150
    next i
'.............................................
109:
    LED.iall(0)
    MATRIX.setfont(1)
    for i = 0 to 8
     for d = 0 to 5
      MATRIX.select(d)
      gosub 200 ' Farbe
      if d = 0 then t = (IO.getrtc(3)) / 10 ' Tag
      if d = 1 then t = (IO.getrtc(3)) % 10 ' Tag
      if d = 2 then t = (IO.getrtc(4)) / 10 ' Monat
      if d = 3 then t = (IO.getrtc(4)) % 10 ' Mona
      if d = 4 then t = ((IO.getrtc(5)) % 100) / 10 ' Jahr
      if d = 5 then t = ((IO.getrtc(5)) % 100) % 10 ' Jahr
      if d % 2 = 0 then MATRIX.char(1, i, t, 1) else MATRIX.char(0, i, t, 1)
     next d
     LED.show()
     if i = 0 then delay 2000 else delay 40
     LED.iall(0)
    next i
'.............................................
' SHOW Temp
    t = IO.sys(97, 0) ' Chip-Temp
    if t < 0 then w = 0 else w = 1 ' minus / plus flag
    if t < 0 then t = -1 * t ' minus zu plus wegen Anzeige
    t = t / 4 ' real-temp
    LED.iall(0)
    for i = 8 downto 0
     MATRIX.setfont(1)
     d = 4
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(2, i, 10, 1) ' 
     MATRIX.setfont(2)
     d = 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, i, 67, 1) ' C
     d = 0
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, i, 84, 1) ' T
     d = 1
     MATRIX.select(d)
     gosub 200 ' Farbe
     if w = 1 then MATRIX.char(0, i, 43, 1) ' plus
     if w = 0 then MATRIX.char(0, i, 45, 1) ' minus
     d = 2
     MATRIX.select(d)
     gosub 200 ' Farbe
     if t / 10 <> 0 then MATRIX.char(0, i, t / 10, 1) else MATRIX.char(0, i, 32, 1) ' Temp oder leer
     d = 3
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, i, t % 10, 1) ' Temp
     LED.show()
     if i = 0 then delay 2000 else delay 40
    next i
    if (IO.eeread(10)) > 1 gosub 1000 ' Digit Play ausblendend
    k = IO.getkey() ' reset key
    goto 100 ' Uhr
'===========================================================
' Helligkeit
110:
    v = read 41, IO.eeread(1) ' Helligkeit
    if v = 0 then v = IO.getldr() * 2 ' Helligkeit sensor
    if v > 255 then v = 255 ' max bei ldr
    if v < 14 then v = 14 ' min bei ldr
    return
'===========================================================
' Farbe
' d = digit , c = farbspiel
200:
    if z < 32670 then z = z + 1 else z = 0
    if c = 0 then LED.ihsv(1, read 42, c, 255, v) ' rot
    if c = 1 then LED.ihsv(1, read 42, c, 255, v) ' orange
    if c = 2 then LED.ihsv(1, read 42, c, 255, v) ' gelb
    if c = 3 then LED.ihsv(1, read 42, c, 255, v) ' grn
    if c = 4 then LED.ihsv(1, read 42, c, 255, v) ' blau
    if c = 5 then LED.ihsv(1, read 42, c, 255, v) ' magenta
    if c = 6 then LED.ihsv(1, read 42, d, 255, v) ' RGB all
    if c = 7 then LED.ihsv(1, (z / 30) % 360, 255, v) ' farbfade
    if c = 8 then LED.ihsv(1, 0, 0, v) ' weiss
    if c = 9 then LED.ihsv(1, ((read 42, d) + z / 8) % 360, 255, v) ' RGB fade 1
    if c = 10 then LED.ihsv(1, (d * 40 + z) % 360, 255, v) ' RGB fade 2
    if c = 11 then LED.ihsv(1, (d * 10 + z / 30 ) % 360, 255, v) ' RGB fade 3
    if c = 12 then LED.ihsv(1, 22, 205, v) ' incandecent
    return
'===========================================================
' show alarm
300:
    if (IO.eeread(10)) > 1 gosub 1000 ' Digit Play ausblendend
    LED.ihsv(1, 0, 255, v) 'rot
    MATRIX.select(0)
    MATRIX.char(0, 1, 65, 1) 'A
    MATRIX.select(1)
    MATRIX.char(0, 1, 108, 1) 'l
    for i = 0 to 60
     MATRIX.select(2)
     t = IO.eeread(3)
     LED.ihsv(1, 0, 255, ((random % 256) * v) / 256) 'rot
     MATRIX.char(0, 1, t / 10, 1)
     MATRIX.select(3)
     LED.ihsv(1, 0, 255, ((random % 256) * v) / 256) 'rot
     MATRIX.char(0, 1, t % 10, 1)
     MATRIX.select(4)
     t = IO.eeread(4)
     LED.ihsv(1, 0, 255, ((random % 256) * v) / 256) 'rot
     MATRIX.char(0, 1, t / 10, 1)
     MATRIX.select(5)
     LED.ihsv(1, 0, 255, ((random % 256) * v) / 256) 'rot
     MATRIX.char(0, 1, t % 10, 1)
     LED.show()
     delay 50
    next i
    if (IO.eeread(10)) > 1 gosub 1000 ' Digit Play ausblendend
    k = IO.getkey() ' reset key
    goto 100 ' Uhr
'===========================================================
' show random
400:
    y = 0
    for w = 0 to 30
     if w = 30 then s = IO.getrtc(0) else s = random % 100
     if w = 30 then m = IO.getrtc(1) else m = random % 100
     if w = 30 then n = IO.getrtc(2) else n = random % 100
     for i = 0 to 8
      for d = 0 to y
       MATRIX.select(d)
       if d % 2 = 0 then MATRIX.shift(2, 1) else MATRIX.shift(3, 1) ' UP / DOWN
       if d % 2 = 1 and i = 0 then MATRIX.line(0, 0, 4, 0, 0)
       gosub 200 ' Farbe
       if d = 0 then MATRIX.char(0, 8 - i, n / 10, 1)
       if d = 1 then MATRIX.char(0, i - 8, n % 10, 1)
       if d = 2 then MATRIX.char(0, 8 - i, m / 10, 1)
       if d = 3 then MATRIX.char(0, i - 8, m % 10, 1)
       if d = 4 then MATRIX.char(0, 8 - i, s / 10, 1)
       if d = 5 then MATRIX.char(0, i - 8, s % 10, 1)
      next d
      LED.show()
      delay 1 + w * 2
     next i
     if y < 5 then y = y + 1
    next w
    k = IO.getkey() ' reset key
    goto 100 ' Uhr
'===========================================================
' Alarm Music
410:
    MATRIX.setfont(2)
    for d = 0 to 5
     MATRIX.select(d)
     LED.ihsv(1, 0, 255, 240)
     MATRIX.char(0, 0, read 35, d, 1) ' Alarm!
    next d
    LED.show()
' Music end
420:
    x = -1 ' bei Alarm ntig
    b = 0
440:
    t = read 39, b
    i = read 39, b + 1
    b = b + 2
    if t = 255 goto 450
    if t = 0 goto 445
    IO.beep(t)
445:
    delay i*2
    IO.beep(0)
    delay 100
    k = IO.getkey()
    if k <> 0 goto 480
    goto 440
450:
    b = 0
460:
    t = read 40, b
    i = read 40, b + 1
    b = b + 2
    if t = 255 goto 470
    if t = 0 goto 465
    IO.beep(t)
465:
    delay i*2
    IO.beep(0)
    delay 100
    k = IO.getkey()
    if k <> 0 goto 480
    goto 460
470:
    delay 1000
480:
    LED.blackout()
    c = IO.eeread(9) ' Farbe
    IO.eewrite(6, 0)
    a = 0
    goto 100 ' main loop
'===========================================================
' Encoderauwertung
500:
    x = 0
    IO.setenc(0, 9, 0)
510:
    e = IO.getenc()
    if y <> e then x = 0
    if y <> e then y = e
    if e = 0 gosub 520 ' Alarm
    if e = 1 gosub 530 ' AutoDa
    if e = 2 gosub 540 ' TaBeep
    if e = 3 gosub 550 ' Random
    if e = 4 gosub 560 ' Hell
    if e = 5 gosub 570 ' AlZeit
    if e = 6 gosub 580 ' Zeit
    if e = 7 gosub 590 ' Datum
    if e = 8 gosub 600 ' Farbe
    if e = 9 gosub 610 ' UhrAni
    LED.show()
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k <> 0 then x = 0
    if k = 11 goto 99 ' Uhr
    if k = 1 and e = 0 gosub 525 ' Alarm An / Aus
    if k = 1 and e = 1 gosub 535 ' AutoDatum / Temp An / Aus
    if k = 1 and e = 2 gosub 545 ' TastenBeep An / Aus
    if k = 1 and e = 3 gosub 555 ' Random An / Aus
    if k = 1 and e = 4 gosub 565 ' Helligkeit 0-15
    if k = 1 and e = 5 gosub 575 ' Alarm Zeit
    if k = 1 and e = 6 gosub 585 ' Zeit
    if k = 1 and e = 7 gosub 595 ' Datum
    if k = 1 and e = 8 gosub 605 ' Farbe 0-12
    if k = 1 and e = 9 gosub 615 ' UhrAni
    x = x + 1
    if x > 300 goto 99 ' Uhr
    delay 10
    goto 510
'...................................
' An
515:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 23, d, 1) ' An
    next d
    return
' Aus
516:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 24, d, 1) ' Aus
    next d
    return
'===========================================================
' Alarm
520:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 22, d, 1) ' Alarm
    next d
    return
'...................................
' Alarm An / Aus
525:
    if (IO.eeread(2)) = 0 then IO.setenc(0, 1, 0) else IO.setenc(1, 1, 0) ' set encoder
526:
    if (IO.getenc()) = 0 gosub 516 else gosub 515' Aus / An
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 526
    gosub 9100 ' beep bei Tastendruck
    IO.eewrite(2, IO.getenc()) ' Alarm An / Aus
    IO.setenc(e, 9, 0) ' reset encoder
    return
'===========================================================
' AutoDatum / Temp
530:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 21, d, 1) ' AutoDa
    next d
    return
'...................................
' AutoDatum / Temp An / Aus
535:
    if (IO.eeread(5)) = 0 then IO.setenc(0, 1, 0) else IO.setenc(1, 1, 0) ' set encoder
536:
    if (IO.getenc()) = 0 gosub 516 else gosub 515' Aus / An
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 536
    gosub 9100 ' beep bei Tastendruck
    IO.eewrite(5, IO.getenc()) ' AutoDatum / Temp An / Aus
    IO.setenc(e, 9, 0) ' reset encoder
    return
'===========================================================
' TaBeep
540:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 25, d, 1) ' TaBeep
    next d
    return
'...................................
' TastenBeep An / Aus
545:
    if (IO.eeread(7)) = 0 then IO.setenc(0, 1, 0) else IO.setenc(1, 1, 0) ' set encoder
546:
    if (IO.getenc()) = 0 gosub 516 else gosub 515' Aus / An
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 546
    gosub 9100 ' beep bei Tastendruck
    IO.eewrite(7, IO.getenc()) ' TaBeep An / Aus
    IO.setenc(e, 9, 0) ' reset encoder
    return
'===========================================================
' Random
550:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 26, d, 1) ' Random
    next d
    return
'...................................
' Random An / Aus
555:
    if (IO.eeread(8)) = 0 then IO.setenc(0, 1, 0) else IO.setenc(1, 1, 0) ' set encoder
556:
    if (IO.getenc()) = 0 gosub 516 else gosub 515' Aus / An
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 556
    gosub 9100 ' beep bei Tastendruck
    IO.eewrite(8, IO.getenc()) ' Random An / Aus
    IO.setenc(e, 9, 0) ' reset encoder
    return
'===========================================================
' Helligkeit
560:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 27, d, 1) ' Hell
    next d
    return
'...................................
' Helligkeit
565:
    y = IO.eeread(1)
    IO.setenc(y, 15, 0) ' set encoder
566:
    if y <> (IO.getenc()) gosub 567
    for d = 0 to 3
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 27, d, 1) ' Hell
    next d
    MATRIX.select(5)
    MATRIX.char(0, 0, y % 10, 1) ' 0-9
    MATRIX.select(4)
    MATRIX.char(0, 0, y / 10, 1) ' 0-9
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 566
    gosub 9100 ' beep bei Tastendruck
    IO.setenc(e, 9, 0) ' reset encoder
    return
567:
    y = IO.getenc()
    IO.eewrite(1, y) ' Helligkeit
    gosub 110 ' Helligkeit
    return
'===========================================================
' Alarm Zeit
570:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 28, d, 1) ' AlZeit
    next d
    return
'...................................
' Alarm Zeit
575:
    y = 0 ' Flag
    m = IO.eeread(4) ' Alarm Minute
    n = IO.eeread(3) ' Alarm Stunde
576:
    s = IO.getrtc(0) ' SEKUNDEN
    if y = 0 then IO.setenc(n, 23, 0) else IO.setenc(m, 59, 0) ' set encoder
    MATRIX.select(5)
    MATRIX.char(0, 0, m % 10, 2) ' 0-9
    if y = 1 and s & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(4)
    MATRIX.char(0, 0, m / 10, 2) ' 0-9
    if y = 1 and s & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(3)
    MATRIX.char(0, 0, n % 10, 2) ' 0-9
    if y = 0 and s & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(2)
    MATRIX.char(0, 0, n / 10, 2) ' 0-9
    if y = 0 and s & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(1)
    MATRIX.char(0, 0, 90, 2) ' Z
    MATRIX.select(0)
    MATRIX.char(0, 0, 65, 2) ' A
    LED.show()
    delay 10
    if x <> (IO.getenc()) gosub 578
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 then y = y + 1
    if y > 1 then y = 0
    if k <> 11 goto 576
    IO.eewrite(3, n)   ' Alarm Zeit Stunde
    IO.eewrite(4, m)   ' Alarm Zeit Minute
    IO.setenc(e, 9, 0) ' reset encoder
    return
578:
    if y = 0 then n = IO.getenc() else m = IO.getenc()
    x = IO.getenc()
    return
'===========================================================
' Zeit
580:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 29, d, 1) ' Zeit
    next d
    return
'...................................
' Zeit
585:
    y = 0 ' Flag
    s = IO.getrtc(0) ' SEKUNDEN
    m = IO.getrtc(1) ' MINUTEN
    n = IO.getrtc(2) ' STUNDEN
586:
    if y = 0 then IO.setenc(n, 23, 0) ' set encoder
    if y = 1 then IO.setenc(m, 59, 0) ' set encoder
    if y = 2 then IO.setenc(s, 59, 0) ' set encoder
    i = IO.getrtc(0) ' SEKUNDEN
    MATRIX.select(5)
    MATRIX.char(0, 0, s % 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(4)
    MATRIX.char(0, 0, s / 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(3)
    MATRIX.char(0, 0, m % 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(2)
    MATRIX.char(0, 0, m / 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(1)
    MATRIX.char(0, 0, n % 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(0)
    MATRIX.char(0, 0, n / 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    LED.show()
    delay 10
    if x <> (IO.getenc()) gosub 588
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 then y = y + 1
    if y > 2 then y = 0
    if k <> 11 goto 586
    IO.setrtc(2, n)   ' Stunde
    IO.setrtc(1, m)   ' Minute
    IO.setrtc(0, s)   ' Sekunde
    IO.setenc(e, 9, 0) ' reset encoder
    return
588:
    if y = 0 then n = IO.getenc()
    if y = 1 then m = IO.getenc()
    if y = 2 then s = IO.getenc()
    x = IO.getenc()
    return
'===========================================================
' Datum
590:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 30, d, 1) ' Datum
    next d
    return
'...................................
' Datum
595:
    y = 0 ' Flag
    s = (IO.getrtc(5)) % 100 ' Jahr
    m = IO.getrtc(4) ' Monat
    n = IO.getrtc(3) ' Tag
596:
    if y = 0 then IO.setenc(n, 31, 0) ' Tag
    if y = 1 then IO.setenc(m, 12, 0) ' Monat
    if y = 2 then IO.setenc(s, 99, 0) ' Jahr
    i = IO.getrtc(0) ' SEKUNDEN
    MATRIX.select(5)
    MATRIX.char(0, 0, s % 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(4)
    MATRIX.char(0, 0, s / 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(3)
    MATRIX.char(0, 0, m % 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(2)
    MATRIX.char(0, 0, m / 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(1)
    MATRIX.char(0, 0, n % 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(0)
    MATRIX.char(0, 0, n / 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    LED.show()
    delay 10
    if x <> (IO.getenc()) gosub 598
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 then y = y + 1
    if y > 2 then y = 0
    if k <> 11 goto 596
    IO.setrtc(3, n)   ' Tag
    IO.setrtc(4, m)   ' Monat
    IO.setrtc(5, 2000 + s) ' Jahr
    IO.setenc(e, 9, 0) ' reset encoder
    return
598:
    if y = 0 then n = IO.getenc()
    if y = 1 then m = IO.getenc()
    if y = 2 then s = IO.getenc()
    x = IO.getenc()
    return
'===========================================================
' Farbe
600:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 33, d, 1) ' Farb
    next d
    return
'...................................
' Farbe
605:
    y = IO.eeread(9)
    IO.setenc(y, 12, 0) ' set encoder
606:
    if y <> (IO.getenc()) gosub 607
    for d = 0 to 3
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 33, d, 1) ' Farb
    next d
    MATRIX.select(5)
    MATRIX.char(0, 0, y % 10, 1) ' 0-9
    MATRIX.select(4)
    MATRIX.char(0, 0, y / 10, 1) ' 0-9
    LED.show()
    delay 10
    if z < 32670 then z = z + 1 else z = 0
    gosub 9000 ' GETKEY
    if k <> 1 goto 606
    gosub 9100 ' beep bei Tastendruck
    IO.setenc(e, 9, 0) ' reset encoder
    return
607:
    y = IO.getenc()
    IO.eewrite(9, y) ' Farbe
    c = y
    return
'===========================================================
' Uhr Animation
610:
    for d = 0 to 5
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 34, d, 1) ' UhrAni
    next d
    return
'...................................
' Uhr Animation
615:
    y = IO.eeread(10)
    IO.setenc(y, 2, 0) ' set encoder
616:
    if y <> (IO.getenc()) gosub 617
    for d = 0 to 4
     MATRIX.select(d)
     gosub 200 ' Farbe
     MATRIX.char(0, 0, read 34, d, 1) ' UhrAn
    next d
    MATRIX.select(5)
    MATRIX.char(0, 0, y, 1) ' 0-9
    LED.show()
    delay 10
    gosub 9000 ' GETKEY
    if k <> 1 goto 616
    gosub 9100 ' beep bei Tastendruck
    IO.setenc(e, 9, 0) ' reset encoder
    return
617:
    y = IO.getenc()
    IO.eewrite(10, y) 'UhrAn
    return
'===========================================================
' Digit Play ausblendend
1000:
    w = random % 6 ' SHIFT
    for i = 0 to 8
     for d = 0 to 5
      MATRIX.select(d)
      if w = 0 and d % 2 = 0 then MATRIX.shift(2, 1) ' UP
      if w = 0 and d % 2 = 0 and i = 0 then MATRIX.line(0, 7, 4, 7, 0) ' UP clear line
      if w = 0 and d % 2 = 1 then MATRIX.shift(3, 1) ' DOWN
      if w = 0 and d % 2 = 1 and i = 0 then MATRIX.line(0, 0, 4, 0, 0) ' DOWN clear line
      if w = 1 then MATRIX.shift(2, 1) ' UP
      if w = 1 and i = 0 then MATRIX.line(0, 7, 4, 7, 0) ' UP clear line
      if w = 2 then MATRIX.shift(3, 1) ' DOWN
      if w = 2 and i = 0 then MATRIX.line(0, 0, 4, 0, 0) ' DOWN clear line
      if w = 3 then MATRIX.shift(0, 1) ' LEFT
      if w = 3 and i = 0 then MATRIX.line(4, 0, 4, 7, 0) ' LEFT clear line
      if w = 4 then MATRIX.shift(1, 1) ' RIGHT
      if w = 4 and i = 0 then MATRIX.line(0, 0, 0, 7, 0) ' RIGHT clear line
      if w = 5 and d % 2 = 0 then MATRIX.shift(0, 1) ' LEFT
      if w = 5 and d % 2 = 1 then MATRIX.shift(1, 1) ' RIGHT
      if w = 5 and d % 2 = 0 and i = 0 then MATRIX.line(4, 0, 4, 7, 0) ' LEFT clear line
      if w = 5 and d % 2 = 1 and i = 0 then MATRIX.line(0, 0, 0, 7, 0) ' RIGHT clear line
      gosub 200 ' Farbe
     next d
     LED.show()
     if w < 3 delay 60 else delay 90
     if w > 2 and i = 5 then i = 8
    next i
    x = IO.getrtc(0) ' SEKUNDEN
    w = 0 ' shift
    return
'================================================
' Show Logo
2000:
    LED.blackout()
    for i = 8 downto 0
     for d = 0 to 5
      MATRIX.select(d)
      LED.ihsv(1, read 42, d, 255, v)
      MATRIX.char(0, i, read 20, d, 1) ' Logo
      'MATRIX.char(0, i-8, read 20, d, 1) ' Logo
     next d
     LED.show()
     delay 100
    next i
    delay 2000
    for i = 0 to 8
     for d = 0 to 5
      MATRIX.select(d)
      LED.ihsv(1, read 42, d, 255, v)
      MATRIX.char(0, i, read 20, d, 1) ' Logo
      MATRIX.line(0, i-1, 4, i-1, 0) ' clear line
      'MATRIX.char(0, 0-i, read 20, d, 1) ' Logo
      'MATRIX.line(0, 0-i+8, 4, 0-i+8, 0) ' clear line
     next d
     LED.show()
     delay 100
    next i
    delay 100
    for i = 8 downto 0
     for d = 0 to 5
      MATRIX.select(d)
      LED.ihsv(1, read 42, d, 255, v)
      MATRIX.char(0, i, read 18, d, 1) ' Olaf
     next d
     LED.show()
     delay 100
    next i
    delay 2000
    for i = 0 to 8
     for d = 0 to 5
      MATRIX.select(d)
      LED.ihsv(1, read 42, d, 255, v)
      MATRIX.char(0, i, read 18, d, 1) ' Olaf
      MATRIX.line(0, i-1, 4, i-1, 0) ' clear line
     next d
     LED.show()
     delay 100
    next i
    delay 100
    return

' Zufalls-Pixel
3000:
     for i = 1 to 500
      t = random % 360 ' Farbe
      d = random % 239 ' LED
      led.lhsv(d, t, 255, v)
      d = random % 239 ' LED
      led.lrgb(d, 0, 0, 0) ' clear pixel
      t = random % 360 ' Farbe
      d = random % 239 ' LED
      led.lhsv(d, t, 255, v)
      d = random % 239 ' LED
      led.lrgb(d, 0, 0, 0) ' clear pixel
      led.show()
      delay 40
     next i
     LED.blackout()
     goto 100

 ' Farbbalken horizontal
3100:
    LED.blackout()
    for i = 1 to 10
     t = random % 360 ' Color
     LED.ihsv(20,t,255,v)
      for b = 0 to 7 ' Row
       for d = 0 to 5 ' Matrix
        MATRIX.select(d)
        MATRIX.line(0, b, 4, b, 20)
        MATRIX.line(0, b-1, 4, b-1, 0) ' clear line
       next d
       led.show()
       delay 100
      next b
      for b = 7 downto 0 ' Row
       for d = 0 to 5 ' Matrix
        MATRIX.select(d)
        MATRIX.line(0, b, 4, b, 20)
        MATRIX.line(0, b+1, 4, b+1, 0) ' clear line
       next d
       led.show()
       delay 100
      next b
     next i
     LED.blackout()
     goto 100

 ' Farbbalken vertikal
3200:
    LED.blackout()
    for i = 1 to 10
     t = random % 360 ' Color
     LED.ihsv(20,t,255,v)
     for b = 0 to 5 ' Matrix
      for d = 0 to 4 ' Column
       MATRIX.select(b)
       MATRIX.line(d, 0, d, 7, 20)
       MATRIX.line(d-1, 0, d-1, 7, 0) ' clear line
       led.show()
       delay 40
      next d
     next b
     t = random % 360 ' Color
     LED.ihsv(20,t,255,v)
     for b = 5 downto 0 ' Matrix
      for d = 4 downto 0 ' Column
       MATRIX.select(b)
       MATRIX.line(d, 0, d, 7, 20)
       MATRIX.line(d+1, 0, d+1, 7, 0) ' clear line
       led.show()
       delay 40
      next d
     next b
    next i
    LED.blackout()
    goto 100

 ' Zufallszeichen
3300:
    LED.blackout()
    for i = 1 to 10
     t = random % 360 ' Color
     LED.ihsv(20,t,255,v)
     for b = 0 to 5 ' Matrix
      d = 32 + (random % 95) ' char
      MATRIX.select(b)
      MATRIX.char(0, 0, d, 20)
      led.show()
      delay 400
     next b
    next i
    LED.blackout()
    goto 100
'===========================================================
' MODE Stoppuhr
5000:
    c = 4 ' blau
    gosub 110 ' helligkeit
    for i = 0 to 14
     for d = 0 to 5
      MATRIX.select(d)
      gosub 200 ' Farbe
      MATRIX.char(0, 0, read 31, d + i, 1) ' Stoppuhr
     next d
     LED.show()
     delay 120
     gosub 9000 ' GETKEY
     if k <> 0 gosub 9100 ' beep bei Tastendruck
     if k <> 0 then i = 14
    next i
    if k = 11 goto 6000 ' Timer
    if k = 0 goto 5000
    IO.eewrite(6, 1) ' Mode Stoppuhr
    s = 0
    m = 0
    n = 0
    gosub 104' show Time (Stoppuhr)
    LED.show()
    goto 5020
5010:
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 goto 5020 ' stopp
    if k = 11 then IO.eewrite(6, 0) ' Mode Uhr
    if k = 11 goto 99 ' Uhr
    if x = (IO.getrtc(0)) goto 5010
    x = IO.getrtc(0)
    gosub 110 ' helligkeit
    gosub 104 ' show Time (Stoppuhr)
    LED.show()
    if (IO.eeread(2)) = 1 and (IO.eeread(3)) = (IO.getrtc(2)) and (IO.eeread(4)) = (IO.getrtc(1)) goto 200 ' alarm prio
    if s < 59 then s = s + 1 else s = 0
    if s = 0 then m = m + 1
    if m = 60 then n = n + 1
    if m = 60 then m = 0
    if n = 24 goto 420 ' MAX Music end
    goto 5010
5020:
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 goto 5010 ' go
    if k = 11 goto 5000 ' auswahlmen
    if (IO.eeread(2)) = 1 and (IO.eeread(3)) = (IO.getrtc(2)) and (IO.eeread(4)) = (IO.getrtc(1)) goto 200 ' alarm prio
    delay 20
    goto 5020
'===========================================================
' MODE Timer
6000:
    c = 3 ' grn
    gosub 110 ' helligkeit
    for i = 0 to 11
     for d = 0 to 5
      MATRIX.select(d)
      gosub 200 ' Farbe
      MATRIX.char(0, 0, read 32, d + i, 1) ' Timer
     next d
     LED.show()
     delay 120
     gosub 9000 ' GETKEY
     if k <> 0 gosub 9100 ' beep bei Tastendruck
     if k <> 0 then i = 11
    next i
    if k = 11 then IO.eewrite(6, 0) ' Mode Uhr
    if k = 11 goto 99 ' Uhr
    if k = 0 goto 6000
    IO.eewrite(6, 2) ' Mode Timer
    s = 0
    m = 0
    n = 0
'.......................
' Timer set
    y = 0 ' Flag
6020:
    i = IO.getrtc(0) ' SEKUNDEN
    if y = 0 then IO.setenc(n, 23, 0) ' set encoder
    if y = 1 then IO.setenc(m, 59, 0) ' set encoder
    if y = 2 then IO.setenc(s, 59, 0) ' set encoder
    MATRIX.select(5)
    MATRIX.char(0, 0, s % 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(4)
    MATRIX.char(0, 0, s / 10, 2) ' 0-9
    if y = 2 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(3)
    MATRIX.char(0, 0, m % 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(2)
    MATRIX.char(0, 0, m / 10, 2) ' 0-9
    if y = 1 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(1)
    MATRIX.char(0, 0, n % 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    MATRIX.select(0)
    MATRIX.char(0, 0, n / 10, 2) ' 0-9
    if y = 0 and i & 1 = 0 then MATRIX.line(0, 7, 4, 7, 1)
    LED.show()
    delay 10
    if x <> (IO.getenc()) gosub 6060
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 then y = y + 1
    if y > 2 then y = 0
    if k <> 11 goto 6020
'............................
' Timer start
6040:
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 goto 6050 ' stopp
    if k = 11 then IO.eewrite(6, 0) ' Mode Uhr
    if k = 11 goto 99 ' Uhr
    if x = (IO.getrtc(0)) goto 6040
    x = IO.getrtc(0)
    gosub 110 ' helligkeit
    gosub 104 ' show Time (Timer)
    LED.show()
    if (IO.eeread(2)) = 1 and (IO.eeread(3)) = (IO.getrtc(2)) and (IO.eeread(4)) = (IO.getrtc(1)) goto 200 ' alarm prio
    if s > 0 then s = s - 1 else s = 59
    if s = 59 then m = m - 1
    if m < 0 then n = n - 1
    if m < 0 then m = 59
    if n < 0 goto 420 ' Timer Music end
    goto 6040
6050:
    gosub 9000 ' GETKEY
    if k <> 0 gosub 9100 ' beep bei Tastendruck
    if k = 1 goto 6040 ' go
    if k = 11 goto 6000 ' auswahlmen
    if (IO.eeread(2)) = 1 and (IO.eeread(3)) = (IO.getrtc(2)) and (IO.eeread(4)) = (IO.getrtc(1)) goto 200 ' alarm prio
    delay 20
    goto 6050
'............................
6060:
    if y = 0 then n = IO.getenc()
    if y = 1 then m = IO.getenc()
    if y = 2 then s = IO.getenc()
    x = IO.getenc()
    return
'===========================================================
' EEPROM INIT
8000:
    print "Resetting EEPROM..."
    IO.eewrite(0, 102)    ' 0 = Version (102)
    IO.eewrite(1, 8)      ' 1 = Helligkeit (5)
    IO.eewrite(2, 0)      ' 2 = Alarm  (0)
    IO.eewrite(3, 12)     ' 3 = Alarm Zeit Stunde (12)
    IO.eewrite(4, 0)      ' 4 = Alarm Zeit Minute (0)
    IO.eewrite(5, 0)      ' 5 = Datum / Temp auto Anzeige (0)
    IO.eewrite(6, 0)      ' 6 = Mode  (0)
    IO.eewrite(7, 1)      ' 7 = Tasten-Beep  (1)
    IO.eewrite(8, 0)      ' 8 = Random Modus (Spielautomat) (0)
    IO.eewrite(9, 12)     ' 9 = Farbe  (12 incandecent)
    IO.eewrite(10, 0)     ' 10 = Uhr Animation (0)
    print "EEPROM reset."
    IO.beep(35)
    delay 500
    IO.beep(0)
    return
'===========================================================
' GETKEY
' k: 0 = No Key, k + 10 = LONG, k = SHORT
9000:
    k = IO.getkey()
    if k = 0 return
    i = 0
9010:
    t = IO.keystate()
    if t = 0 return
    delay 10
    i = i + 1
    if i < 50 goto 9010
    k = t + 10
    return
'===========================================================
' BEEP
9100:
    if (IO.eeread(7)) = 0 then return ' beep aus
    IO.beep(35)
    delay 25
    IO.beep(0)
    return
'......................
9200:
    if (IO.eeread(7)) = 0 goto 100 ' beep aus
9205:
    x = -1 ' bei Alarm ntig
    IO.beep(35)
    delay 25
    IO.beep(0)
    goto 100 ' Uhr
'===========================================================
end
